{$M 16384,0,0}
uses Dos;

const
  translator : string = 'BPC.EXE';
  sername : string = '';
  checker : string = '';
  errors : string = '';
  time : integer = 3;
  firsttest : integer = 1;
  lasttest : integer = 1;

type
  vect_t = array [byte] of pointer;

var
  Int8Save : Pointer;
  VecSave : vect_t;
  Vec : vect_t absolute 0:0;
  T : Longint; TimeOut : boolean;
  SSS: String;

{$F+,S-,W-}
procedure TimerHandler; interrupt;
  label m1;
  begin
    asm
      pushf
      call Int8Save
    end;
    dec( T );
    if T=0 then
      begin
        TimeOut := true;
        asm
          mov ah, 62h
          int 21h
          mov ax, cs
          mov bx, ax
          jc m1
         { mov ax, 4CFFh }
         { int 21h }
         int 23h
        end;
        Vec := VecSave;
      end;
    m1:
  end;

procedure StartProg( s : string; i : longint );
begin
  T := 18 * i; TimeOut := False;
  VecSave := Vec;
  SwapVectors;
  GetIntVec($8,Int8Save);
  SetIntVec($8,@TimerHandler);
  Exec( s, '' );
  SetIntVec($8,Int8Save);
  SwapVectors;
  if DosError <> 0 then
    begin WriteLn('I can''t execute ', s, '.'); halt; end;
end;

{$F-,S+}

procedure readline( var f : text; var n, v : string );
  procedure deltrim( var s : string );
  begin
    while (length( s )>0)and( s[length(s)] = ' ' ) do delete( s, length( s ), 1 );
    while (length( s )>0)and( s[1] = ' ' ) do delete( s, 1, 1 );
  end;
var
  s : string;
  i : integer;
begin
  readln( f, s );
  i := pos( ';', s );
  if i > 0 then delete( s, i, high( s ) );
  i := pos( '=', s );
  if i = 0 then
    begin n := ''; v := s; end
  else
    begin
      n := copy( s, 1, i - 1 );
      v := copy( s, i + 1, high( s ) );
    end;
  deltrim( n ); deltrim( v )
end;
procedure toupper( var s : string );
var i : integer;
begin
  for i := 1 to length( s ) do s[i] := UpCase( s[i] )
end;
procedure DoVal( s : string; var i : integer );
var i2 : integer; j : word;
begin
  val( s, i2, j );
  if j = 0 then i := i2
end;

procedure DoParam( s : string );
var i : integer;
begin
  if (length( s ) > 1)and(s[1] in ['-','/']) then
    case UpCase(s[2]) of
      '?' :
         begin
           writeln( 'TESTER' ); writeln;
           writeln( 'Switches:' );
           writeln( '  -N<name> name of task' );
           writeln( '  -C<name> set checker' );
           writeln( '  -E<name> errors file name' );
           writeln( '  -R<name> translator' );
           writeln( '  -T<number> time for one test (0 - infinity)' );
           writeln( '  -F<number> first test' );
           writeln( '  -L<number> last test' );
           writeln( '  -O<number> do one test' );
           writeln;
           writeln( 'Name of .cfg-file variables:' );
           writeln( '  name, checker, errors, time, first, last, trnslator.' );
           halt
         end;
      'T' :
        begin
          DoVal( Copy( s, 3, high( s ) ), time );
        end;
      'F' :
        begin
          DoVal( Copy( s, 3, high( s ) ), firsttest );
        end;
      'L' :
        begin
          DoVal( Copy( s, 3, high( s ) ), lasttest );
        end;
      'O' :
        begin
          i := -1;
          DoVal( Copy( s, 3, high( s ) ), i );
          if i>=0 then begin firsttest := i; lasttest := i; end;
        end;
      'N' : sername := Copy( s, 3, high( s ) );
      'C' : checker := Copy( s, 3, high( s ) );
      'E' : errors := Copy( s, 3, high( s ) );
      'R' : translator := Copy( s, 3, high( s ) );
      else
        writeln( 'Invalid switch - ', s[2] )
    end
  else
    writeln( 'What is this? - ', s );
end;

function CopyFile( s, d : string ) : boolean;
var
  t : string;
  fs, fd : text;
begin
  CopyFile := false;
  assign( fs, s ); assign( fd, d );
  {$I-} reset( fs ); {I+} if IOResult <> 0 then exit;
  rewrite( fd );
  while not eof( fs ) do
{    if eoln( fs ) then
      begin
        readln( fs ); writeln( fd )
      end
    else   }
      begin
        readln( fs, t ); writeln( fd, t )
      end;
  close( fd );
  close( fs );

  CopyFile := true;
end;

function Check( i, o, o2,SSS : string ) : boolean;
var
  f1, f2 : text;
  c1, c2 : char;
begin
  Check := false;
  assign( f1, o ); assign( f2, o2 );
  {$I-} reset( f1 ); {$I+}
  if IOResult <> 0 then exit;
  {$I-} reset( f2 ); {$I+}
  if IOResult <> 0 then
    begin Writeln( 'File ', o2, 'not found' ); close( f2 ); exit; end;

  if checker <> '' then
    begin
      close( f1 ); close( f2 );
      SwapVectors;
      Exec( checker, o+' '+o2 );
      SwapVectors;
      if DosError <> 0 then
        begin WriteLn('I can''t execute ', checker, '.'); halt; end
      else
        begin
          case DosExitCode of
            2 :;
            5 : Check := true;
          else
            begin
              Writeln( 'Checker return invalid value.' ); {halt};
            end
          end
        end
    end
  else
    begin
      while not seekeof( f1 ) do
        begin
          if seekeof( f2 ) then begin close( f1 ); close( f2 ); exit; end;
          repeat
            if eoln(f1) then c1 := ' ' else read( f1, c1 );
            if eoln(f2) then c2 := ' ' else read( f2, c2 );
          until (Upcase( c1 )<>Upcase( c2 )) or (c1 = ' ') or
            seekeof( f1 ) or seekeof( f2 );

          if seekeof( f1 ) xor seekeof( f2 )
            then begin close( f1 ); close( f2 ); exit; end;

          if (Upcase( c1 )<>Upcase( c2 ))
            then begin close( f1 ); close( f2 ); exit; end;
        end;
      Check := seekeof( f2 );
      close( f1 ); close( f2 )
    end;
end;

var
  fc, fe : text;
  s1, s2, si, so : string;

  P: PathStr;
  D: DirStr;
  N: NameStr;
  E: ExtStr;

  i, Count : integer;

  Right : set of byte;

begin
  {ClrScr;}
  FSplit(ParamStr(0), D, N, E);
  assign( fc, D + N + '.CFG' );
  {$I-} reset( fc ); {$I+}
  if IOResult = 0 then
    begin
      while not seekeof( fc ) do
        begin
          readline( fc, s1, s2 );
          toupper( s1 );
          if s1 = 'NAME' then sername := s2
          else if s1 = 'TIME' then DoVal( s2, time )
          else if s1 = 'FIRST' then DoVal( s2, firsttest )
          else if s1 = 'LAST' then DoVal( s2, lasttest )
          else if s1 = 'CHECKER' then checker := s2
          else if s1 = 'ERRORS' then errors := s2
          else if s1 = 'TRANSLATOR' then errors := s2
        end;
      close( fc );
    end;
  for i := 1 to ParamCount do
    DoParam( ParamStr( i ) );

  if sername = '' then
    begin Writeln( 'Define name of problem.' ); halt; end;

  if translator = '' then
    begin Writeln( 'Define name of translator.' ); halt; end
  else if pos('.',translator) = 0 then
    translator := translator + '.EXE';
  toupper( translator );

  P := FSearch(translator,GetEnv('PATH'));
  if P = '' then
    begin WriteLn( translator, ' not found' ); halt; end
  else
    begin
      SwapVectors;
      Exec( P, sername );
      SwapVectors;
      if DosError <> 0 then{ Error? }
        begin WriteLn('Can''t execute BPC.EXE'); halt; end
      else if DosExitCode<>0 then
        begin Writeln; Writeln( 'Program wasn''t be compiled successfuly.' ); halt; end;
    end;

  if firsttest > lasttest then halt;

  if (checker<>'')and(pos('.',checker)=0) then checker := checker + '.EXE';

  assign( fe, errors ); rewrite( fe ); close( fe );

  Right := [];
  for i := firsttest to lasttest do
    begin
      str( i, s1 );
      SSS:=s1;
      s2 := sername + s1 + '.OUT';
      s1 := sername + s1 + '.IN';
      si := sername + '.IN'; so := sername + '.OUT';
      assign( fc, so );
      {$I-} erase( fc ); {$I+}
      if IOResult = 0 then;
      if CopyFile( s1, si ) then
        begin
          Write( 'Start test ', i, '...' );
          StartProg( sername + '.EXE', time );
          if TimeOut then Writeln( ' Time out' ) else Writeln( ' Done.');
          if Check( s1, so, s2,SSS ) then Include( Right, i )
          else if errors <> '' then
            begin
              append( fe );
              writeln( fe, '******* Test #', i );
              {$I-} reset( fc ); {$I+}
              if IOResult <> 0 then
                if TimeOut then
                  writeln( fe, '******* Time out.' )
                else
                  writeln( fe, '******* Result absent.' )
              else
                begin
                  while not eof(fc) do
                    if eoln( fc ) then
                      begin
                        readln( fc ); writeln( fe )
                      end
                    else
                      begin
                        read( fc, s1 ); write( fe, s1 )
                      end;
                  close( fc );
                end;
              writeln( fe );
              close( fe );
            end;
        end
      else
        Writeln( 'Test ', i, ' is absent.' );
    end;
  Writeln( '_________________' ); Writeln;
  if firsttest = lasttest then
    if Right = [] then Writeln( 'Incorrect answer' ) else Writeln( 'Right answer.' )
  else
    if Right = [] then
      Writeln( 'No right answers' )
    else
      begin
        Write( 'Right answer(s) in test(s):' );
        Count := 0;
        for i := firsttest to lasttest do
          if i in Right then begin Write( ' ', i ); Inc( Count ); end;
        Writeln( '.' ); Writeln( 'Total - ', Count )
      end
end.

